% FEEC/Unicamp
% 28/05/2017
% Visualization of the results produced by two nonlinear principal components
% Use of the weights obtained after training the neural network
% One-hidden layer NN before the bottleneck
% Kinematics of Robot Arm (http://www.dcc.fc.up.pt/~ltorgo/Regression/DataSets.html)
%
clear all;
load w1;load w2;load evol;
load kine; % Training data
N = length(X(:,1));
n(1,1) = length(w1(:,1));
n(2,1) = length(w2(:,1));
r = n(2);
m = length(w1(1,:))-1;
np1 = n(1)*(m+1);np2 = n(2)*(n(1)+1);
n_weights = np1+np2;
disp(sprintf('No. of training patterns = %d',N));
disp(sprintf('No. of hidden layer neurons = %d',n(1)));
disp(sprintf('No. of weights = %d',n_weights));
disp(sprintf('No. of iterations = %d',n_iter));
Srn = [tanh([S ones(N,1)]*w1') ones(N,1)]*w2';
figure(2);
plot(Srn(:,1),Srn(:,2),'*r');
title('Visualization of the results produced by two nonlinear principal components');
